
#include "ControlWindow.h"
#include "MySlider.h"
#include "vidsource.h"

ControlWindow::ControlWindow(BTSVideoSource *videoSource)
	: BWindow(BRect(79,100,269,245),"Control Panel",B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_ZOOMABLE),
	fVideoSource(videoSource)
{
	BView		*bg;

	Lock();
	
	bg=new BView(BRect(0,0,190,145),"",B_FOLLOW_ALL,B_WILL_DRAW);
	bg->SetViewColor(210,210,210);

/*
	rMenu=new BPopUpMenu("rMenu");
	rField=new BMenuField(BRect(10,10,170,25),"rField","Resolution:",rMenu,B_FOLLOW_LEFT|B_FOLLOW_TOP);

	dMenu=new BPopUpMenu("dMenu");
	dField=new BMenuField(BRect(10,40,170,55),"dField","Depth:",dMenu,B_FOLLOW_LEFT|B_FOLLOW_TOP);
	
	newItem=new BMenuItem("80 x 60",new BMessage(mSMALL));
	newItem->SetTarget(theVideoWindow);
	rMenu->AddItem(newItem);
	newItem=new BMenuItem("160 x 120",new BMessage(mMEDIUM));
	newItem->SetTarget(theVideoWindow);
	rMenu->AddItem(newItem);
	newItem->SetMarked(TRUE);
	newItem=new BMenuItem("320 x 240",new BMessage(mLARGE));
	newItem->SetTarget(theVideoWindow);
	rMenu->AddItem(newItem);

	newItem=new BMenuItem("4-Bits/Pixel",new BMessage(m4BITS));
	newItem->SetTarget(theVideoWindow);
	dMenu->AddItem(newItem);
	newItem->SetMarked(TRUE);
	newItem=new BMenuItem("6-Bits/Pixel",new BMessage(m6BITS));
	newItem->SetTarget(theVideoWindow);
	dMenu->AddItem(newItem);

	bg->AddChild(rField);
	bg->AddChild(dField);
*/
	
	BTSCenteredSlider *newSlider=new BTSCenteredSlider(BRect(13,55,177,55+B_H_SCROLL_BAR_HEIGHT),"hue",new BMessage(mHUE),HUE);
	newSlider->SetTarget(this);
	bg->AddChild(newSlider);
	
	newSlider=new BTSCenteredSlider(BRect(13,75,177,75+B_H_SCROLL_BAR_HEIGHT),"saturation",new BMessage(mSATURATION),SATURATION);
	newSlider->SetTarget(this);
	bg->AddChild(newSlider);

	newSlider=new BTSCenteredSlider(BRect(13,95,177,95+B_H_SCROLL_BAR_HEIGHT),"brightness",new BMessage(mBRIGHTNS),BRIGHTNESS);
	newSlider->SetTarget(this);
	bg->AddChild(newSlider);

	newSlider=new BTSCenteredSlider(BRect(13,115,177,115+B_H_SCROLL_BAR_HEIGHT),"contrast",new BMessage(mCONTRAST),CONTRAST);
	newSlider->SetTarget(this);
	bg->AddChild(newSlider);
		
	AddChild(bg);

	Unlock();
}

void 
ControlWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case mHUE:
			fVideoSource->SetHue(msg->FindLong("value"));
		break;
		case mSATURATION:
			fVideoSource->SetSaturation(msg->FindLong("value"));
		break;

		case mBRIGHTNS:
			fVideoSource->SetBrightness(msg->FindLong("value"));
		break;

		case mCONTRAST:
			fVideoSource->SetContrast(msg->FindLong("value"));
		break;
		
	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}

bool ControlWindow::QuitRequested(void)
{
/*
	Hide();
	//be_app->MainMenu()->ItemAt(1)->SetMarked(FALSE);
	return FALSE;
*/

	return TRUE;
}
